#include <minix/config.h>
#if (CHIP == M68000) && defined(FPP)

|
| public labels
|
.globl	__fppsave
.globl	__fppsavereg
.globl	__fpprestore
.globl	__fpprestreg

.text
|
| void _fsave(char *p)
| save fpp context
|
__fppsave:
	movel	a7@(4),a0
	fsave	a0@
	rts	

|
| void _fppsavereg(char *p)
| save fpp register set
|
__fppsavereg:
	movel	a7@(4),a0
	fmoveml	fpcr/fpsr/fpiar,a0@+
	fmovemx	fp0-fp7,a0@
	rts	

|
| void _fpprestore(char *p)
| restore fpp context
|
__fpprestore:
	movel	a7@(4),a0
	frestore	a0@
	rts	

|
| void _fpprestreg(char *p)
| restore fpp register set
|
__fpprestreg:
	movel	a7@(4),a0
	fmoveml	a0@+,fpcr/fpsr/fpiar
	fmovemx	a0@,fp0-fp7
	rts	

#endif
