/*
	defines and datastructures needed for m68851 PMMU
*/
#define PCSR_FLSH	0x8000
#define PCSR_LW		0x4000
#define PCSR_AMSK	0x0007

#define AC_MC		0x0080
#define AC_ALC		0x0030
#define AC_MDS		0x0003

#ifdef _ANSI
#define BITFIELDS
#endif

struct _tc {		/* translation control */
#ifdef BITFIELDS
	unsigned	enable:1;
	unsigned	res1:5;
	unsigned	sre:1;
	unsigned	fcl:1;
	unsigned	ps:4;
	unsigned	is:4;
	unsigned	tia:4;
	unsigned	tib:4;
	unsigned	tic:4;
	unsigned	tid:4;
#else
	unsigned short	ctrl;
	unsigned short	ti;
#endif
};

struct _rpr {		/* root pointer descriptor */
#ifdef BITFIELDS
	unsigned	ul:1;
	unsigned	limit:15;
	unsigned 	res1:6;
	unsigned	sg:1;	/* 0 in 68030, used in 68851 */
	unsigned	res2:7;
	unsigned	dt:2;
#else
	unsigned short	limit;
	unsigned short	dt;
#endif
	unsigned long	ta;	/* lower 4 bits are not used */
};

struct _ltd {		/* long format table descriptor */
#ifdef BITFIELDS
	unsigned	ul:1;
	unsigned	limit:15;

	unsigned	ral:3;	/* 111 in 68030, used in 68851 */
	unsigned	wal:3;	/* 111 in 68030, used in 68851 */
	unsigned	sg:1;	/* 0 in 68030, used in 68851 */
	unsigned	s:1;
	unsigned	res1:4;
	unsigned	u:1;
	unsigned	wp:1;
	unsigned 	dt:2;
#else
	unsigned short	limit;
	unsigned short	ctrl;
#endif

	unsigned long	ta;	/* lower 4 bits are not used */
};



#define DT_INVALID	0
#define DT_PAGE		1
#define DT_TYPE1	2
#define DT_TYPE2	3

#define PSR_BUS		0x8000
#define PSR_LIM		0x4000
#define PSR_SUP		0x2000
#define PSR_ACC		0x1000	/* 0 in 68030, used in 68851 */
#define PSR_WRT		0x0800
#define PSR_INV		0x0400
#define PSR_MOD		0x0200
#define PSR_GAT		0x0100	/* 0 in 68030, used in 68851 */
#define PSR_GLO		0x0080	/* 0 in 68030, used in 68851 */
#define PSR_NMSK	0x0007


