#include "type.S"

| offsets in this boot block:
#define sizes	480
#define magic	502
#define nsect	504
#define fsckd	506
#define zero	508
#define fsckt	510

#define BIOS	13
#define RWABS	4
#define GETBPB	7

#define _bootdev	0x0446
#define ldaddr		0x020000

boot:
	movew	_bootdev,sp@-
	movew	#GETBPB,sp@-
	trap	#BIOS
	addw	#4,sp
	tstl	d0
	beq	fail
	clrw	d6			| start with block 0
	lea	pc@(start+sizes),a4	| address of sector table
	addw	#1,a4@			| count boot block
	movel	#ldaddr,a3		| load address in memory
read:
	clrl	d4			| load sectors from disc
	movew	a4@+,d4
	beq	4f			| count of 0 means loading finished
	bsr	rwabs
	bne	fail
	addw	d4,d6
	asll	#8,d4
	asll	#1,d4
	addl	d4,a3

	clrl	d0			| create bss area of part
	movew	a4@+,d0
	asll	#8,d0
	beq	read
3:
	clrw	a3@+
	subl	#1,d0
	bne	3b
	bra	read
4:
| calculate end of loaded image
| keep this value in d2 for future reference
	clrl	d2
	movew	pc@(start+nsect),d2
	asll	#8,d2			| multiply
	asll	#1,d2			| with 512
	addl	#ldaddr,d2
	movel	d2,a0
	lea	pc@(copy),a1		| copy copy routine to the end of the image
	movel	#128,d0			| to avoid that it overwrites itself
5:	movel	a1@+,a0@+		| 512 bytes is definitely enough.
	dbf	d0,5b

	movel	d2,a1
#ifdef __mc68020__
| if there is no mmu the pmove will cause a trap. Catch it
| and jump to the copy routine in that case
	movel	a1,0x2c
| disable the mmu. This is needed because on the TT tos has
| initialised the mmu when we get here.
	clrl	a0@
	pmove	a0@,tc
#endif
	jmp	a1@			| jump to new copy routine

copy:
	lea	pc@(copy),a0
	movew	#0x2700,sr
	movel	#8,a0
| save the minix boot address. It will be overwritten during the copy
	movel	ldaddr+0x204,a3
	movel	#ldaddr+0x208,a1	| start address of minix
3:	movel	a1@+,a0@+
	cmpl	a1,d2			| d2 contains the end of the loaded image
	bne	3b
	jmp	a3@			| minix boot address

fail:
	clrl	d0			| cannot load MINIX; try next device
	rts	

rwabs:
	movew	_bootdev,sp@-
	movew	d6,sp@-
	movew	d4,sp@-
	movel	a3,sp@-
	clrw	sp@-
	movew	#RWABS,sp@-
	trap	#BIOS
	addw	#14,a7
	tstw	d0
	rts	
